package javax.xml.stream;

import javax.xml.stream.events.DTD;
import javax.xml.stream.events.ProcessingInstruction;
import javax.xml.stream.events.Comment;
import javax.xml.stream.events.EntityReference;
import javax.xml.stream.events.EntityDeclaration;
import javax.xml.stream.events.EndDocument;
import javax.xml.stream.events.StartDocument;
import javax.xml.stream.events.Characters;
import javax.xml.stream.events.EndElement;
import javax.xml.namespace.NamespaceContext;
import javax.xml.stream.events.StartElement;
import java.util.Iterator;
import javax.xml.stream.events.Namespace;
import javax.xml.namespace.QName;
import javax.xml.stream.events.Attribute;

public abstract class XMLEventFactory
{
    static final String JAXPFACTORYID = "javax.xml.stream.XMLEventFactory";
    static final String DEFAULIMPL = "com.sun.xml.internal.stream.events.XMLEventFactoryImpl";
    
    protected XMLEventFactory() {
    }
    
    public static XMLEventFactory newInstance() throws FactoryConfigurationError {
        return (XMLEventFactory)FactoryFinder.find(XMLEventFactory.class, "com.sun.xml.internal.stream.events.XMLEventFactoryImpl");
    }
    
    public static XMLEventFactory newFactory() throws FactoryConfigurationError {
        return (XMLEventFactory)FactoryFinder.find(XMLEventFactory.class, "com.sun.xml.internal.stream.events.XMLEventFactoryImpl");
    }
    
    @Deprecated
    public static XMLEventFactory newInstance(String factoryId, ClassLoader classLoader) throws FactoryConfigurationError {
        return (XMLEventFactory)FactoryFinder.find(XMLEventFactory.class, factoryId, classLoader, null);
    }
    
    public static XMLEventFactory newFactory(String factoryId, ClassLoader classLoader) throws FactoryConfigurationError {
        return (XMLEventFactory)FactoryFinder.find(XMLEventFactory.class, factoryId, classLoader, null);
    }
    
    public abstract void setLocation(Location p0);
    
    public abstract Attribute createAttribute(String p0, String p1, String p2, String p3);
    
    public abstract Attribute createAttribute(String p0, String p1);
    
    public abstract Attribute createAttribute(QName p0, String p1);
    
    public abstract Namespace createNamespace(String p0);
    
    public abstract Namespace createNamespace(String p0, String p1);
    
    public abstract StartElement createStartElement(QName p0, Iterator p1, Iterator p2);
    
    public abstract StartElement createStartElement(String p0, String p1, String p2);
    
    public abstract StartElement createStartElement(String p0, String p1, String p2, Iterator p3, Iterator p4);
    
    public abstract StartElement createStartElement(String p0, String p1, String p2, Iterator p3, Iterator p4, NamespaceContext p5);
    
    public abstract EndElement createEndElement(QName p0, Iterator p1);
    
    public abstract EndElement createEndElement(String p0, String p1, String p2);
    
    public abstract EndElement createEndElement(String p0, String p1, String p2, Iterator p3);
    
    public abstract Characters createCharacters(String p0);
    
    public abstract Characters createCData(String p0);
    
    public abstract Characters createSpace(String p0);
    
    public abstract Characters createIgnorableSpace(String p0);
    
    public abstract StartDocument createStartDocument();
    
    public abstract StartDocument createStartDocument(String p0, String p1, boolean p2);
    
    public abstract StartDocument createStartDocument(String p0, String p1);
    
    public abstract StartDocument createStartDocument(String p0);
    
    public abstract EndDocument createEndDocument();
    
    public abstract EntityReference createEntityReference(String p0, EntityDeclaration p1);
    
    public abstract Comment createComment(String p0);
    
    public abstract ProcessingInstruction createProcessingInstruction(String p0, String p1);
    
    public abstract DTD createDTD(String p0);
}
